class Rtpl::Parser < Parslet::Parser
  root(:block)

  rule(:block) { (open_block.as(:open) >> (nested_block | not_block).repeat.as(:content) >> close_block.as(:close) >> spc?).repeat(1) }

  rule(:block?) { block.maybe }

  rule(:open_block)  { comment >> open_sym >> name.as(:name) >> end_comment }
  rule(:close_block) { comment >> close_sym >> name.as(:name) >> end_comment }

  rule(:nested_block) { not_block.repeat.as(:before) >> block >> not_block.repeat.as(:after) }

  rule(:not_block?)  { not_block.maybe }
  rule(:not_block)   { (open_block | close_block).absent? >> (var | text) }
  rule(:not_blocks)  { not_block.repeat }

  rule(:comment)     { str('<!--') >> spc? }
  rule(:end_comment) { spc? >> str('-->') >> spc? }

  rule(:close_sym) { spc? >> str('END:') >> spc? }
  rule(:open_sym)  { spc? >> str('BEGIN:') >> spc?}

  rule(:var)   { str('{') >> name.as(:var_name) >> str('}') }
  rule(:text)  { any.as(:text) }
  rule(:name)  { match('\w').repeat(1) }

  rule(:space) { match('\s').repeat(1) }
  rule(:spc?)  { space.maybe }
end
